Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');  
Components.utils.import("resource://gre/modules/Services.jsm"); 
Components.utils.import('resource://gre/modules/ctypes.jsm');  

function Win7AppId() {  
}  
  
Win7AppId.prototype = {  
  
    // XPCOM
    classDescription: 'Windows 7 Taskbar AppId Setter',
    classID: Components.ID('{207331f1-1f2f-4ef6-8bc6-5c2a148f4ce3}'),
    contractID: '@didroe/win7appid;1',
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIObserver]),

    // nsIObserver
    // This will get called when the profile has loaded
    observe: function(aSubject, aTopic, aData) {
        var toolkitProfileService = Components.classes['@mozilla.org/toolkit/profile-service;1'].createInstance(Components.interfaces.nsIToolkitProfileService);
        
        // We'd like to use toolkitProfileService.selectedProfile but this turns out to
        // be the last one selected in the profile manager, not the one currently in use!
        // Instead we loop over the profiles looking for the one that matches the current 
        // profile dir.
        var profileDir = Services.dirsvc.get('ProfD', Components.interfaces.nsIFile).path;
        var profileName;
        var profiles = toolkitProfileService.profiles;
        while (profiles.hasMoreElements()) {
            let profile = profiles.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
            if (profile.rootDir.path == profileDir) {
                profileName = profile.name;
            }
        }
        
        var lib = ctypes.open('shell32.dll');  

        // HRESULT SetCurrentProcessExplicitAppUserModelID(__in  PCWSTR AppID);
        var appId = lib.declare('SetCurrentProcessExplicitAppUserModelID',  
                                ctypes.winapi_abi, // ABI
                                ctypes.int32_t,    // Return type
                                ctypes.jschar.ptr);  
        appId('Mozilla.Firefox.' + profileName);

        lib.close();    
    }
    
}; 

const NSGetFactory = XPCOMUtils.generateNSGetFactory([Win7AppId]);
